/** @typedef {import('@vue/cli/lib/GeneratorAPI')} GeneratorAPI */

/**
 * @param {GeneratorAPI} api
 * @param {any} options
 */
module.exports = (api, options) => {
  api.extendPackage({
    devDependencies: {
      vuelidate: '^0.7.4'
    }
  })

  api.injectImports(api.entryFile, `import Vuelidate from 'vuelidate'`)

  api.onCreateComplete(() => {
    const fs = require('fs')
    const content = fs.readFileSync(api.entryFile, { encoding: 'utf-8' })
    const lines = content.split(/\r?\n/g)
    const importIndex = lines.filter(line => line.match(/^import/)).length

    lines.splice(importIndex + 1, 0, 'Vue.use(Vuelidate)')

    fs.writeFileSync(api.entryFile, lines.join('\r\n'), { encoding: 'utf-8' })
  })
}
